//
//               INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//        Copyright (c) 2015 Intel Corporation. All Rights Reserved.
//

#pragma once

#include <map>
#include "simple_allocator_dx9.h"
#include "simple_allocator_dx11.h"
#include "mfxjpeg.h"

#define  CHECK_STS(STS, EXPECTED, MESSAGE) \
if (STS != EXPECTED){                      \
    std::cout << MESSAGE << "\n";          \
    assert(STS == EXPECTED);               \
    return STS;                            \
}

struct sInputParams
{
    mfxIMPL impl;
    mfxU32  n_frames;
    mfxU32  width;
    mfxU32  height;
    mfxU32  fourcc;
    mfxU32  chroma_format;
    mfxU32  enc_codec;
    mfxU32  async_depth;

    bool bVPP;

    mfxU32 new_width;
    mfxU32 new_height;

    bool delay_sync;
    bool system_memory;

    bool raw_output;
    char raw_output_file_name[MAX_FILENAME_LEN];

    bool enc_output;
    char enc_output_file_name[MAX_FILENAME_LEN];

    bool debug; //wait for debugger to be attached

    mfxU32 wait;
    mfxU32 limit_fps;
};